//
//  kjots
//
//  Copyright (C) 1997 Christoph Neerfeld
//  Copyright (C) 2002, 2003 Aaron J. Seigo
//  Copyright (C) 2003 Stanislav Kljuhhin
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#ifndef __KJOTSENTRY_H
#define __KJOTSENTRY_H

#include <klistview.h>

//
// class KJotsEntryBase
//

class KURL;

class KJotsEntryBase:public KListViewItem
{
//	Q_OBJECT
public:
	KJotsEntryBase(KListView*,QListViewItem*);
	KJotsEntryBase(KListViewItem*,QListViewItem*);

public:
	void setSubject(const QString&);
	QString subject(void) {return text(0);}
	void setText(int,const QString&);
	virtual bool isBook(void)=0;
	virtual bool saveToFile(KURL)=0;
};

//
// class KjotsBook
//

class KJotsBook:public KJotsEntryBase
{
//	Q_OBJECT
public:
	KJotsBook(KListView*, QString, QListViewItem* after = 0);
	~KJotsBook();

public:
	bool openBook(void);
	void closeBook(void);
	void annihilateBook(void);
	bool isBook(void) { return true; }
	void startRename(int);
	QString beforeRename(void) { return m_beforeRename; }
	void setDeleteFlag(void) { m_deleteFlag = true; }
	bool saveToFile(KURL);

private:
	bool m_open;
	bool m_deleteFlag;
	QString m_beforeRename;
};

//
// class KJotsSubject
//

class KJotsSubject:public KJotsEntryBase
{
//	Q_OBJECT
public:
	KJotsSubject(KJotsBook*, QString, QListViewItem* after = 0);

public:
	QString body(void);
	void setBody(const QString&);
	void write(QTextStream &st);
	bool isBook(void) { return false; }
	bool saveToFile(KURL);

private:
	QString m_text;
};

#endif // __KJOTSENTRY_H
/* ex: set tabstop=4 softtabstop=4 shiftwidth=4 expandtab: */
